=begin
This exporter was written by akemp (c) 2012.
Use a triangulation utility (triangulateFaces.rb recommended) FIRST!
Then run this script with "Plugins>RawExport Selected Faces Only" or (recommended) "RawExport Entire Model" 
Turn text files exported by the script to usable .obj files with the included executable.
=end
###
###
def SetUpTextures(model)
  count = 0
  materials=model.materials
  materials.each{
  |mat|
  if (mat.texture!=nil)
    mat.texture.size = 1024
  end#if
  }
  return "Textures normalized."
end#def
def RunScript(model, selection)
  deflist = model.definitions
  path=Sketchup.active_model.path.tr("\\", "/")
  if not path or path==""
    UI.messagebox("RawExport:\n\nSave the SKP before exporting it as text\n")
    return nil
  end#if
  number = path.rindex("/")
  if (number == nil)
    UI.messagebox("RawExport:\n\nPath error: could not export to " + path)
    return nil
  end
  number += 1
  name = path[number..-1]
  name = name.tr(".skp", "") + ".txt"
# Create/open a file in write mode
  f = File.open name, "w"
  
  if (selection != nil)
  model.selection.each{|e|
    if e.class == Sketchup::Component
      if e.class==Sketchup::Face
        face=e
        mat = face.material
        if (mat != nil)
          tex = mat.texture
          if (tex != nil)
            number += 1
            f.write tex.filename
            f.write "\n"
            vert = face.vertices
            f.write vert.size
            f.write "\n"
            tw = Sketchup.create_texture_writer
            uvHelp = face.get_UVHelper true, true, tw
            vert.each{
              |point|
              f.write point.position[0].to_m
              f.write " "
              f.write point.position[1].to_m
              f.write " "
              f.write point.position[2].to_m
              f.write "\n"
              uvq = uvHelp.get_front_UVQ(point.position)
              f.write uvq.x.to_m 
              f.write " "
              f.write uvq.y.to_m
              f.write "\n"
            }
          end
        end
        mat = face.back_material
        if (mat != nil)
          tex = mat.texture
          if (tex != nil)
            number += 1
            f.write tex.filename
            f.write "\n"
            vert = face.vertices.reverse
            f.write vert.size
            f.write "\n"
            tw = Sketchup.create_texture_writer
            uvHelp = face.get_UVHelper true, true, tw
            vert.each{
              |point|
              f.write point.position[0].to_m
              f.write " "
              f.write point.position[1].to_m
              f.write " "
              f.write point.position[2].to_m
              f.write "\n"
              uvq = uvHelp.get_back_UVQ(point.position)
              f.write uvq.x.to_m 
              f.write " "
              f.write uvq.y.to_m
              f.write "\n"
            }
          end
        end
      end#if 
  end
  }
  end
  if (selection == nil)
  deflist.each{
    |definition|
    definition.entities.each{|e|
      if e.class==Sketchup::Face
        face=e
        mat = face.material
        if (mat != nil)
          tex = mat.texture
          if (tex != nil)
            number += 1
            f.write tex.filename
            f.write "\n"
            vert = face.vertices
            f.write vert.size
            f.write "\n"
            tw = Sketchup.create_texture_writer
            uvHelp = face.get_UVHelper true, true, tw
            vert.each{
              |point|
              f.write point.position[0].to_m
              f.write " "
              f.write point.position[1].to_m
              f.write " "
              f.write point.position[2].to_m
              f.write "\n"
              uvq = uvHelp.get_front_UVQ(point.position)
              f.write uvq.x.to_m 
              f.write " "
              f.write uvq.y.to_m
              f.write "\n"
            }
          end
        end
        mat = face.back_material
        if (mat != nil)
          tex = mat.texture
          if (tex != nil)
            number += 1
            f.write tex.filename
            f.write "\n"
            vert = face.vertices.reverse
            f.write vert.size
            f.write "\n"
            tw = Sketchup.create_texture_writer
            uvHelp = face.get_UVHelper true, true, tw
            vert.each{
              |point|
              f.write point.position[0].to_m
              f.write " "
              f.write point.position[1].to_m
              f.write " "
              f.write point.position[2].to_m
              f.write "\n"
              uvq = uvHelp.get_back_UVQ(point.position)
              f.write uvq.x.to_m 
              f.write " "
              f.write uvq.y.to_m
              f.write "\n"
            }
          end
        end
      end#if
      }
  }
  end#if
  # Close the file
  f.close
  return name
end
 plugins_menu = UI.menu("Plugins")
 submenu = plugins_menu.add_submenu("RawExport")
 item = submenu.add_item("RawExport Entire Model") {
  name = RunScript(Sketchup.active_model, nil) 
  UI.messagebox "RawExport: Faces exported as text to " + name
  }
 item = submenu.add_item("RawExport Selected Faces Only") {
  name = RunScript(Sketchup.active_model, 1) 
  UI.messagebox "RawExport: Faces exported as text to " + name
  }
 item = submenu.add_item("Normalize UV") {
  name = SetUpTextures(Sketchup.active_model)
  UI.messagebox name
  }
